<script setup lang="ts">
// import { title } from 'process'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Member } from '@/types/Member'
import { useMemberStore } from '@/stores/member';
import member from '@/services/member';

const memberStore = useMemberStore()
const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  { key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    memberStore.clearForm()
})
}

async function deleteItemConfirm() {
  // Delete item from list
  await memberStore.deleteMember()
  closeDelete()
}

async function editItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialog.value = true
}

async function deleteItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await memberStore.saveMember()
}

onMounted(() => {
  memberStore.getMembers()
})

</script>

<template>
  <div>
    <v-data-table style="background-color: #efe7e1" 
    :headers="headers" 
    :items="memberStore.members"
    >
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Member</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                style="color: #0043c7; background-color: #f9f8f5"
                class="custom-button"
                v-bind="props"
                prepend-icon="mdi-plus"
              >
              New Member
              </v-btn>
            </template>

            <v-card>
              <v-card-title>
                <span class="text-h5">Member Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="memberStore.editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6"
                        ><v-text-field
                          v-model="memberStore.editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field
                      ></v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="#81322c" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="#81322c" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="memberStore.getMembers"> Reset </v-btn>
      </template></v-data-table
    >
  </div>
</template>

<style>
.custom-button {
  margin: 5px; /* เว้นระยะห่าง */
  border-radius: 20px; /* make the roundness */
  padding: 10px 20px;
}
</style>async async async 
